//-----------------------------------------------------------------------------
//       Module: Color Picker.PRG         Authors: Craig Veal, Erik Mller
//                                        Modified quite a lot by Peter Rorlick
//  Description: Used to allow user to select colors
//       Tester: Craig Veal            Documentation: Craig Veal
//      Created: 1/24/98       11:25:40AM
// Last updated: 2/19/98      10:35:00AM
//
// Comments: Use right mouse button to switch between foreground
// and background color.
//
//    Copyright: None:  Donated to the public domain by the author
//-----------------------------------------------------------------------------
param cCurrentColors

#define RegularBorder  7   // client
#define SelectedBorder 8   // modal

local f
PRIVATE cColorChoices
PRIVATE lAbort
lAbort = false
_app.OldColor=""
*IF TYPE("cCurrentColors") #"C"
*   cCurrentColors = "BtnText/BtnFace"
*ENDIF
f = NEW COLORSFORM()
*f.rec_fgcolor.colornormal = cCurrentColors
* f.Top = -300
cColorChoices = ""
f.mdi = false // ensure not MDI
f.readModal()
* f.release()
return cColorChoices
**********************************************************************
*CLASS NICEREC(f,n) OF RECTANGLE(f,n)
*
*   this.borderstyle=3
*   this.onmousemove=COLORSFORM::Buttonupdate
*   this.onrightmousedown={;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
*
*ENDCLASS
***********************************************************************
** END HEADER -- do not remove this line
//
// Generated on 04/21/1998
//
parameter bModal
local f
f = new COLORSFORM()
if (bModal)
   f.mdi = false // ensure not MDI
   f.readModal()
else
   f.open()
endif

class COLORSFORM of ZFORM
   set procedure to xtraBtns.cc additive
   with (this)
      onMouseMove = {;class::FlashButton_BlinkOff()}
      scaleFontBold = false
      height = 15.0909
      left = 5.1429
      top = 3.6818
      width = 63
      text = "Select Foreground And Background Colors"
      autoCenter = true
      mdi = false
      sizeable = false
      escExit = false
      maximize = false
      * icon = "FILENAME colors.ico"
   endwith


   this.FGCOLOR = new RADIOBUTTON(this)
   with (this.FGCOLOR)
      height = 1.1364
      left = 0.5714
      top = 0.0455
      width = 14.2857
      text = "&Foreground"
      group = true
      value = true
   endwith


   this.BGCOLOR = new RADIOBUTTON(this)
   with (this.BGCOLOR)
      height = 1.1364
      left = 16.4286
      top = 0.0455
      width = 15.4286
      text = "&Background"
      group = false
      value = false
   endwith


   this.REC_FGCOLOR = new RECTANGLE(this)
   with (this.REC_FGCOLOR)
      onLeftMouseDown = {;Form.BGCOLOR.value=.f.;Form.FGCOLOR.value=.t.;Form.FGCOLOR.SetFocus()}
      left = 0.8571
      top = 1.0455
      width = 13.7143
      height = 1.8182
      text = "Sample"
      colorNormal = "Black"
      border = false
      borderStyle = 7	// Client
   endwith


   this.PB01 = new NICEREC(this)
   with (this.PB01)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 1
      top = 3.5909
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/0x8080ff"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB02 = new NICEREC(this)
   with (this.PB02)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 8.7143
      top = 3.5909
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/0x80ffff"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB03 = new NICEREC(this)
   with (this.PB03)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 16.4286
      top = 3.5909
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/0x80ff80"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB04 = new NICEREC(this)
   with (this.PB04)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 24.1429
      top = 3.5909
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/0x80ff00"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB05 = new NICEREC(this)
   with (this.PB05)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 31.8571
      top = 3.5909
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/0xffff80"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB06 = new NICEREC(this)
   with (this.PB06)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 39.5714
      top = 3.5909
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/0xff8000"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB07 = new NICEREC(this)
   with (this.PB07)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 47.2857
      top = 3.5909
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/0xc080ff"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB08 = new NICEREC(this)
   with (this.PB08)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 55
      top = 3.5909
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/0xff80ff"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB09 = new NICEREC(this)
   with (this.PB09)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 1
      top = 5.1818
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/red"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB10 = new NICEREC(this)
   with (this.PB10)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 8.7143
      top = 5.1818
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/yellow"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB11 = new NICEREC(this)
   with (this.PB11)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 16.4286
      top = 5.1818
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/0xff80"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB12 = new NICEREC(this)
   with (this.PB12)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 24.1429
      top = 5.1818
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/0x40ff00"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB13 = new NICEREC(this)
   with (this.PB13)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 31.8571
      top = 5.1818
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/cyan"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB14 = new NICEREC(this)
   with (this.PB14)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 39.5714
      top = 5.1818
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/0xc08000"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB15 = new NICEREC(this)
   with (this.PB15)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 47.2857
      top = 5.1818
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/0xc08080"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB16 = new NICEREC(this)
   with (this.PB16)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 55
      top = 5.1818
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/magenta"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB17 = new NICEREC(this)
   with (this.PB17)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 1
      top = 6.7727
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/0x404080"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB18 = new NICEREC(this)
   with (this.PB18)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 8.7143
      top = 6.7727
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/0x4080ff"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB19 = new NICEREC(this)
   with (this.PB19)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 16.4286
      top = 6.7727
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/lime"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB20 = new NICEREC(this)
   with (this.PB20)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 24.1429
      top = 6.7727
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/teal"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB21 = new NICEREC(this)
   with (this.PB21)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 31.8571
      top = 6.7727
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/0x804000"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB22 = new NICEREC(this)
   with (this.PB22)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 39.5714
      top = 6.7727
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/0xff8080"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB23 = new NICEREC(this)
   with (this.PB23)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 47.2857
      top = 6.7727
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/0x400080"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB24 = new NICEREC(this)
   with (this.PB24)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 55
      top = 6.7727
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/0x8000ff"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB25 = new NICEREC(this)
   with (this.PB25)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 1
      top = 8.3636
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/maroon"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB26 = new NICEREC(this)
   with (this.PB26)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 8.7143
      top = 8.3636
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/0x80ff"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB27 = new NICEREC(this)
   with (this.PB27)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 16.4286
      top = 8.3636
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/green"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB28 = new NICEREC(this)
   with (this.PB28)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 24.1429
      top = 8.3636
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/0x408000"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB29 = new NICEREC(this)
   with (this.PB29)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 31.8571
      top = 8.3636
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/blue"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB30 = new NICEREC(this)
   with (this.PB30)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 39.5714
      top = 8.3636
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/0xa00000"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB31 = new NICEREC(this)
   with (this.PB31)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 47.2857
      top = 8.3636
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/purple"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB32 = new NICEREC(this)
   with (this.PB32)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 55
      top = 8.3636
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/0xff0080"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB33 = new NICEREC(this)
   with (this.PB33)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 1
      top = 9.9545
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/0x40"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB34 = new NICEREC(this)
   with (this.PB34)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 8.7143
      top = 9.9545
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/0x4080"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB35 = new NICEREC(this)
   with (this.PB35)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 16.4286
      top = 9.9545
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/0x4000"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB36 = new NICEREC(this)
   with (this.PB36)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 24.1429
      top = 9.9545
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/0x404000"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB37 = new NICEREC(this)
   with (this.PB37)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 31.8571
      top = 9.9545
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/navy"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB38 = new NICEREC(this)
   with (this.PB38)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 39.5714
      top = 9.9545
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "white/0x400000"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB39 = new NICEREC(this)
   with (this.PB39)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 47.2857
      top = 9.9545
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "white/0x400040"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB40 = new NICEREC(this)
   with (this.PB40)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 55
      top = 9.9545
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/0x800040"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB41 = new NICEREC(this)
   with (this.PB41)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 1
      top = 11.5455
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "white/black"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB42 = new NICEREC(this)
   with (this.PB42)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 8.7143
      top = 11.5455
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/olive"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB43 = new NICEREC(this)
   with (this.PB43)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 16.4286
      top = 11.5455
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/0x408080"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB44 = new NICEREC(this)
   with (this.PB44)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 24.1429
      top = 11.5455
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnText/gray"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB45 = new NICEREC(this)
   with (this.PB45)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 31.8571
      top = 11.5455
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnFace/0x808040"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB46 = new NICEREC(this)
   with (this.PB46)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 39.5714
      top = 11.5455
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnText/silver"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB47 = new NICEREC(this)
   with (this.PB47)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 47.2857
      top = 11.5455
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnText/0x400040"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.PB48 = new NICEREC(this)
   with (this.PB48)
      onLeftMouseDown = class::COLORSCHANGED
      onRightMouseDown = {;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}
      onMouseMove = class::BUTTONUPDATE
      left = 55
      top = 11.5455
      width = 6.7143
      height = 1.3636
      text = ""
      colorNormal = "BtnText/white"
      border = false
      fontBold = true
      borderStyle = 7	// Client
   endwith


   this.RESULTTEXT = new TEXT(this)
   with (this.RESULTTEXT)
      height = 1.8182
      left = 32.5714
      top = 1.0455
      width = 13.7143
      border = true
      wrap = false
      fontSize = 18
      text = "Result"
      borderStyle = 7	// Client
   endwith


   this.REC_BGCOLOR = new RECTANGLE(this)
   with (this.REC_BGCOLOR)
      onLeftMouseDown = {;Form.FGCOLOR.value=.f.;Form.BGCOLOR.value=.t.;Form.BGCOLOR.SetFocus()}
      left = 16.7143
      top = 1.0455
      width = 13.7143
      height = 1.8182
      text = "Sample"
      colorNormal = "BtnFace"
      border = false
      borderStyle = 7	// Client
   endwith


   this.OKBUTTON = new OKPOPBUTTON(this)
   with (this.OKBUTTON)
      onClick = class::OKBUTTON_ONCLICK
      left = 37
      top = 13.3636
      value = false
   endwith


   this.CANCELBUTTON = new CANCELPOPBUTTON(this)
   with (this.CANCELBUTTON)
      onClick = class::CANCELBUTTON_ONCLICK
      left = 49.8571
      top = 13.3636
      value = false
   endwith


   this.SAMPLETEXT = new TEXT(this)
   with (this.SAMPLETEXT)
      height = 1.8182
      left = 48.4286
      top = 1.0455
      width = 13.7143
      border = true
      wrap = false
      fontSize = 18
      text = "Sample"
      borderStyle = 7	// Client
   endwith


   PROCEDURE COLORSCHANGED
   LOCAL cNewColor
   cNewColor = SUBSTR(this.colornormal,AT("/",this.colornormal)+1)
   IF form.fgcolor.value
      form.rec_fgcolor.colornormal = cNewColor
   ELSE
      form.rec_bgcolor.colornormal = cNewColor
   ENDIF
   form.ResultText.ColorNormal = form.rec_fgcolor.colornormal+'/'+form.rec_bgcolor.colornormal

   FUNCTION OKBUTTON_ONCLICK
*   if form.fgcolor.value
*      cColorChoices = form.rec_fgcolor.colornormal
*   else
*      cColorChoices = form.rec_bgcolor.colornormal
*   endif
   cColorChoices = form.ResultText.ColorNormal
   form.close()

   FUNCTION CANCELBUTTON_ONCLICK
   lAbort = true
   cColorChoices = ""   // added by Pete
   form.close()

*   Proc Init
*   Class::FormUpdate()
   Procedure FormUpdate && --------------------------
   local b
   b=form.first
   do
      if b.classname="NICEREC" .AND. b.borderstyle#RegularBorder
         b.borderstyle = RegularBorder
      endif
      b=b.before
   until b=form.first

   Procedure Buttonupdate && --------------------------
   local b
   if this.borderstyle#SelectedBorder ; this.borderstyle=SelectedBorder ; endif
   b=form.first
   do
      if b.classname="NICEREC" .AND. b.borderstyle#RegularBorder .AND. b # this
         b.borderstyle = RegularBorder
      endif
      b=b.before
   until b=form.first

   LOCAL cFG
   LOCAL cBG
   LOCAL cNewColor

   cNewColor = SUBSTR(this.colornormal,AT("/",this.colornormal)+1)

   IF form.fgcolor.value
      cFG=cNewColor
      cBG=form.rec_bgcolor.colornormal
   ELSE
      cBG=cNewColor
      cFG=form.rec_fgcolor.colornormal
   ENDIF

   If (_app.OldColor <> (cFG+'/'+cBG))
     _app.OldColor = cFG+'/'+cBG
     form.SampleText.ColorNormal = _app.OldColor
   EndIf

   return
endclass
*********************************************************************
**********************************************************************
CLASS NICEREC(f,n) OF RECTANGLE(f,n)

   this.borderstyle=3
   this.onmousemove=COLORSFORM::Buttonupdate
   this.onrightmousedown={;if form.fgcolor.value;form.bgcolor.value=.t.;form.bgcolor.setfocus();else;form.fgcolor.value=.t.;form.fgcolor.setfocus();endif}

ENDCLASS
